unit hiCoder;

interface

uses Kol,Share,Debug;

type
  THICoder = class(TDebug)
  private

  FCharCounter:byte;    //   
  FSum:integer;
  FPassword:string;     // 
  FResByte:integer;
  FResText:string;

  protected

  function RandomGenerator:integer;
  function Coder(bt:byte):byte;
  function Decoder(bt:byte):byte;
  function CodeXor(bt:byte):byte;

  public
  _prop_Password:string;
  _prop_Mode:byte;

  _data_Char:THI_Event;
  _data_Password:THI_Event;
  _event_onResult:THI_Event;

  procedure _work_doRefresh(var _Data:TData; Index:word);
  procedure _work_doCode(var _Data:TData; Index:word);
  procedure _work_doDecode(var _Data:TData; Index:word);
  procedure _work_doXor(var _Data:TData; Index:word);
  procedure _var_Length(var _Data:TData; Index:word);
  procedure _var_ResByte(var _Data:TData; Index:word);
  procedure _var_ResText(var _Data:TData; Index:word);

  end;

implementation

function THICoder.RandomGenerator;
var j,cyrcleCounter: byte;
begin
  cyrcleCounter:=FCharCounter;
  for j:=0 to Length(FPassword)-1 do
  begin
    inc(FSum,ord(FPassword[cyrcleCounter]));
    if cyrcleCounter=Length(FPassword) then
       cyrcleCounter:=0;
    inc(cyrcleCounter);
  end;
  inc(FCharCounter);
  if FCharCounter>Length(FPassword) then FCharCounter:=1;
  if FSum>255 then
   Result:=FSum mod 255 else
   Result:=FSum;
end;

function THICoder.Coder;
var temp:integer;
begin
  temp:=bt - RandomGenerator;
  if temp<0 then temp:=temp + 256;
  Result:=temp;
end;
  
function THICoder.Decoder;
var temp:integer;
begin
  temp:=bt + RandomGenerator;
  if temp>255 then temp:=temp - 256;
  Result:=temp;
end;

function THICoder.CodeXor;
var temp,cyrcleCounter:byte;
var CharPass:string;
begin
  cyrcleCounter:=FCharCounter;
  temp:=ord(FPassword[cyrcleCounter]) xor bt;
  inc(FCharCounter);
  if FCharCounter>Length(FPassword) then FCharCounter:=1;
  Result:=temp;
end;

procedure THICoder._work_doRefresh;
begin
  FPassword:=ReadString(_Data,_data_Password,_prop_Password);
  FCharCounter:=1;
  FSum:=0;
  FResByte:=0;
  FResText:='';
end;

procedure THICoder._work_doCode;
var bt,ch:byte;
var s:string;
begin
  if _prop_Mode=0 then
  begin
    bt:=ReadInteger(_Data,_data_Char,0);
    ch:=Coder(bt);
    FResByte:=ch;
    _hi_OnEvent(_event_onResult,ch);
  end else
  begin
    s:=ReadString(_Data,_data_Char,'');
    bt:=ord(s[1]);
    ch:=Coder(bt);
    s:=chr(ch);
    FResText:=s;
    _hi_OnEvent(_event_onResult,s);
  end;
end;

procedure THICoder._work_doDecode;
var bt,ch:byte;
var s:string;
begin
  if _prop_Mode=0 then
  begin
    bt:=ReadInteger(_Data,_data_Char,0);
    ch:=Decoder(bt);
    FResByte:=ch;
    _hi_OnEvent(_event_onResult,ch);
  end else
  begin
    s:=ReadString(_Data,_data_Char,'');
    bt:=ord(s[1]);
    ch:=Decoder(bt);
    s:=chr(ch);
    FResText:=s;
    _hi_OnEvent(_event_onResult,s);
  end;
end;

procedure THICoder._work_doXor;
var bt,ch:byte;
var s:string;
begin
  if _prop_Mode=0 then
  begin
    bt:=ReadInteger(_Data,_data_Char,0);
    ch:=CodeXor(bt);
    FResByte:=ch;
    _hi_OnEvent(_event_onResult,ch);
  end else
  begin
    s:=ReadString(_Data,_data_Char,'');
    bt:=ord(s[1]);
    ch:=CodeXor(bt);
    s:=chr(ch);
    FResText:=s;
    _hi_OnEvent(_event_onResult,s);
  end;
end;

procedure THICoder._var_Length;
begin
  _Data.data_type := data_int;
  _Data.idata := Length(FPassword);
end;

procedure THICoder._var_ResByte;
begin
  _Data.data_type := data_int;
  _Data.idata := FResByte;
end;
 
procedure THICoder._var_ResText;
begin
  _Data.data_type := data_str;
  _Data.sdata := FResText;
end;

end.
